function X = inplace_perm(X,perm,fast)
N = size(X,2);
if nargin < 2 || isempty(perm)
    perm = ceil(rand(1,N).*(1:N));
end
if nargin < 3
    fast = 0;
end
if fast
    inplace_perm_helper(X,int32(perm));
else
    for n=1:N
        x_n = X(:,n);
        X(:,n) = X(:,perm(n));
        X(:,perm(n)) = x_n;
    end
end