/* Simple test program for the RAD package. */

/* Compute f(n,x) = the product of x[0], x[1], ..., x[n-1] */
/* and the gradient of f for two x values, and print the result. */

//#include "rad.hpp"
#include <stdio.h>
#include "mex.h"   //--This one is required
//#define nanoMatDebug 1 // 1 for safety/error checking; 0 for faster and unsafe(er)
#include "nanoMatT.cpp"
#include "math.h"
#define mmin(X,Y) ((X) < (Y) ? (X) : (Y))
#define mmax(X,Y) ((X) > (Y) ? (X) : (Y))

/*
typedef nanoMat<double> dMat;
typedef nanoMat<int>    iMat;
typedef nanoMat<ADvar> adMat;
typedef ADvar var;
*/


typedef nanoMat<double> dMat;
typedef nanoMat<int>    iMat;
typedef nanoMat<double> adMat;
typedef double var;

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]){
    int i, j, k, l, m, n, y;
    
    dMat  X     = dMat(prhs[0]);
    iMat  perm  = iMat(prhs[1]);
    int M = X.M;
    int N = X.N;
    double tmp;
    for(n=0; n<N; n++){
        for(m=0; m<M; m++){
            tmp=X(m,n);
            X(m,n)=X(m,perm(n)-1);
            X(m,perm(n)-1)=tmp;
        }
        
    }
    
    return;
    
}