function nodes=mytreeval_pca(T,X,At,mu,A)

%for i=1:size(At,1)
%    a{i} = At(i,:);
%end
%nodes = mytreeeval_helper(T.var,T.cut,T.children,X,At,mu);
nodes = mytreeval_pca_helper_fast(T.var,T.cut,T.children,X,A,mu);

end

function nodes = mytreeeval_helper(var,cut,children,X,At,mu)
N = size(X,2);
nodes = zeros(1,N);
for n=1:N
    x = X(:,n)-mu;
    node = 1;
    while var(node)
        i    = var(node);
        %xi   = a{i}*x;
        xi   = At(i,:)*x;
        if xi > cut(node)
            win = 2;
        else
            win = 1;
        end
        node = children(node,win);
    end
    nodes(n) = node;
end

end

% %------------------------------------------------
% function nodes = doapply(Tree,X,rows,thisnode,nodes,subtrees,prunelist,endcol)
% %DOAPPLY Apply classification rule to specified rows starting at a node.
% %   This is a recursive function.  Starts at top node, then recurses over
% %   child nodes.  THISNODE is the current node at each step.
% %
% %   NODES has one row per observation and one column per subtree.
% %
% %   X, NODES, PRUNELIST, and SUBTREES are the same in each recursive call
% %   as they were in the top-level call.  ROWS describes the subset of X and
% %   NODES to consider.  1:ENDCOL are colums of NODES and the elements of
% %   SUBTREES to consider.
% 
% splitvar      = Tree.var(thisnode);
% cutoff        = Tree.cut(thisnode);
% assignedclass = Tree.class(thisnode);
% kids          = Tree.children(thisnode,:);
% catsplit      = Tree.catsplit;
% prunelevel    = prunelist(thisnode);
% ntrees        = size(nodes,2);   % number of trees in sequence
% 
% % For how many of the remaining trees is this a terminal node?
% if splitvar==0      % all, if it's terminal on the unpruned tree
%    ncols = endcol;
% else                % some, if it's terminal only after pruning
%    ncols = sum(subtrees(1:endcol) >= prunelevel);
% end
% if ncols>0          % for those trees, assign the node level now
%    nodes(rows,(endcol-ncols+1:endcol)) = thisnode;
%    endcol = endcol - ncols;
% end
% 
% % Now deal with non-terminal nodes
% if endcol > 0
%    % Determine if this point goes left, goes right, or stays here
%    x = X(rows,abs(splitvar));   
%    if splitvar>0                % continuous variable
%       isleft = (x < cutoff);
%       isright = ~isleft;
%       ismissing = isnan(x);
%    else                         % categorical variable
%       isleft = ismember(x,catsplit{cutoff,1});
%       isright = ismember(x,catsplit{cutoff,2});
%       ismissing = ~(isleft | isright);
%    end
% 
%    subrows = rows(isleft & ~ismissing);  % left child node
%    if ~isempty(subrows)
%       nodes = doapply(Tree,X,subrows,kids(1),nodes,subtrees,prunelist,endcol);
%    end
%    
%    subrows = rows(isright & ~ismissing); % right child node
%    if ~isempty(subrows)
%       nodes = doapply(Tree,X,subrows,kids(2),nodes,subtrees,prunelist,endcol);
%    end
% 
%    subrows = rows(ismissing);            % missing, treat as leaf
%    if ~isempty(subrows)
%       nodes(subrows,1:endcol) = thisnode;
%    end
% end
% 
%    
