function X = decompose_im_pca(im,buf_size,At,mu,step)
    [ly lx num_colors] = size(im);

    bigim = reflectim(im,buf_size);
    X     = zeros( size(At,1), ly*lx);
    

    patches     = zeros( (2*buf_size/step+1)^2*num_colors, ly);
    bigmu = repmat(mu,1,ly);
    
    where = 1;
    for x=1:lx
         decompose_im_helper_1col_lo(bigim,patches,int32(buf_size),int32(ly),int32(lx),int32(num_colors),int32(x),int32(step));
         
         %X(:,where:where+ly-1) = At*(patches-bigmu);
         
         % strangely, faster to break into multiple lines
         patches = patches-bigmu;
         rez     = At*patches;
         X(:,where:where+ly-1) = rez;
         
         where = where + ly;
    end

end