function im_scaled = get_scalespace(im,num_scales)
im_scaled{1} = im;
im = single(im);
for scale=2:num_scales % this is probably not smart
   %im_scaled{scale} = imfilter(im_scaled{scale-1},fspecial('gaussian',5,1),'replicate');
   step  = 2^(scale-1);
   sigma = step/4;
      
   F = fspecial('gaussia',max(3,1+ceil(sigma*4)),sigma);
   mid = (size(F,1)+1)/2;
   f1 = F(mid,:); f1=f1/sum(f1);
   f2 = F(:,mid); f2=f2/sum(f2);
   
   % profiling says first is faster for small scales
   if scale <= 3
       im_scaled{scale} = imfilter(im,F,'replicate');
   else
       im_scaled{scale} = imfilter(imfilter(im,f1,'replicate'),f2,'replicate');
   end
   im_scaled{scale}=double(im_scaled{scale});
end