function test(imsdir,outdir,model)

    % you will need to mess with things (e.g. the filename extensions) to make
    % this work for any particular application

    % Convert the input directory into a cell array
    if ~iscell(imsdir)
        imsdir={imsdir};
    end

    for dirIndex=1:length(imsdir)
        tmpFiles= dir([cell2mat(imsdir(dirIndex)) '/*']);
        curIndex=1;
        for i=1:length(tmpFiles)
            if regexpi(tmpFiles(i).name, '.jpg|.ppm|.bmp|.png') % Include support for different image formats here
                Aims(curIndex,dirIndex)={[cell2mat(imsdir(dirIndex)) '/' tmpFiles(i).name]};
                curIndex=curIndex+1;
            end
        end
    end

    tic
    for i=1:size(Aims,1)
        tmpStr=cell2mat(Aims(i,1));
        % find the name between the file extension and the last '/' symbol
        for j=length(tmpStr)-4:-1:1 
            if tmpStr(j)=='/'
                break
            end
        end
        myname=[tmpStr(j+1:end-4) '.png'];
%         myname = Aims(i).name;
%         myname = myname(1:end-4);
        myA=dir([outdir '/' myname]);
        if 1 %length(myA)==0

            im=[];
            curColorChannel=1;
            for j=1:size(Aims,2)
                tmpIm=double(imread(cell2mat(Aims(i,j))))/255;
                im(:,:,curColorChannel:curColorChannel+size(tmpIm,3)-1)=tmpIm;
                curColorChannel=curColorChannel+size(tmpIm,3);
            end
%             im = double(imread([imsdir    '/' Aims(i).name]))/255;

    %         label = miximshow(classify_image_scaled(im,model));

            gim=classify_image_scaled(im, model);
%             edgeIm = labelshow(im, gim);
            %label = rgb2gray(label);
            %label = label .* double(label>=ordfilt2(label,7,ones(3)));
            %label = repmat(label,[1 1 3]);

    %         imshow([im label]); drawnow
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % Display for the symmetry output
%             figure(100), imagesc(gim(:,:,2), [0 1]);
%             axis image;
%             axis off;
%             set(gcf, 'Position', [100 200 460 345]); drawnow;
            figure(100), imagesc(im(:,:,1:min(size(im,3),3))); colorbar;
            axis image;
            axis off;
            set(gcf, 'Position', [100 200 460 345]); drawnow;
            
            figure(101), imagesc(gim(:,:,2)); colorbar;
            axis image;
            axis off;
            set(gcf, 'Position', [100 600 460 345]); drawnow;
            
            imwrite(gim(:,:,2),[outdir '/' myname]);
            save([outdir '/' myname(1:end-4) '.mat' ],'gim');
            
%             imwrite(gim,[outdir '/' myname]);

            time = toc;
            fprintf('image: %d/%d   time: %f/%f \n', i, size(Aims,1), time, time*size(Aims,1)/i);
        end
    end
end

function testo
    imsdir={'/home/kbits/Data/training-images' '/home/kbits/Research/InnerEdges/code/TestResults'};
    load model2Rep;
    test(imsdir, 'SymmetryResults', model);
end
